---
title: Browser storage limits and eviction criteria
slug: Web/API/IndexedDB_API/Browser_storage_limits_and_eviction_criteria
tags:
  - Database
  - IndexedDB
  - LRU
  - Storage
  - client-side
  - eviction
  - limit
---
<div>{{DefaultAPISidebar("IndexedDB")}}</div>

<p class="summary">There are a number of web technologies that store data of one kind or another on the client-side (i.e., on your local disk). The process by which the browser works out how much space to allocate to web data storage and what to delete when that limit is reached is not simple, and differs between browsers. This article describes how browsers determine what local content to purge and when in order to free up needed local storage space.</p>

<div class="note">
<p><strong>Note</strong>: The information below should be fairly accurate for most modern browsers, but browser specifics are called out where known. Opera and Chrome should behave the same in all cases. <a href="http://www.opera.com/mobile/mini">Opera Mini</a> (still presto-based, server-side rendering) doesn't store any data on the client.</p>
</div>

<h2 id="What_technologies_use_browser_data_storage">What technologies use browser data storage?</h2>

<p>In Firefox, the following technologies make use of browser data storage to store data when required. We term them "quota clients" in this context:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a></li>
 <li><a href="http://asmjs.org/">asm.js</a> caching</li>
 <li><a href="/en-US/docs/Web/API/Cache">Cache API</a></li>
 <li>Cookies</li>
</ul>

<div class="note">
<p><strong>Note</strong>: In Firefox, <a href="/en-US/docs/Web/API/Web_Storage_API">Web Storage</a> will soon start to use the same storage management tools too, as described in this document.</p>
</div>

<div class="note">
<p><strong>Note</strong>: In private browsing mode, most data storage is not supported. Local storage data and cookies are still stored, but they are ephemeral — the data is deleted when you close the last private browsing window.</p>
</div>

<p>The "last access time" of origins is updated when any of these are activated/deactivated — origin eviction will delete data for all these quota clients.</p>

<p>In Chrome/Opera, the Quota Management API handles quota management for <a href="/en-US/docs/Web/HTML/Using_the_application_cache">AppCache</a>, <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a>, WebSQL, and <a href="/en-US/docs/Web/API/File_System_API">File System API</a>.</p>

<h2 id="Different_types_of_data_storage">Different types of data storage</h2>

<p>Even in the same browser, using the same storage method, there are different classes of data storage to understand. This section discusses the different ones you might find in different browsers.</p>

<p>Storage comes in two types:</p>

<ul>
 <li>Persistent: This is data that is intended to be kept around for a long time. This will only be evicted if the user chooses to (for example, in Firefox you can choose to delete all stored data or only stored data from selected origins by going to <em>Preferences</em> and using the options under <em>Privacy &amp; Security &gt; Cookies &amp; Site Data</em>).</li>
 <li>Temporary: This is data that doesn't need to persist for a very long time. This will be evicted under a least recently used ({{anch("LRU policy")}}) when {{anch("Storage limits")}} are reached.</li>
</ul>

<p>In Firefox, when persistent storage is used, the user is given a UI popup to alert them that this data will persist, and asks if they are happy with that. Temporary data storage does not elicit any user prompts.</p>

<p>Storage is temporary by default; developers can choose to use persistent storage for their sites using the {{domxref("StorageManager.persist()")}} method available in the <a href="/en-US/docs/Web/API/Storage_API">Storage API</a>.</p>

<h2 id="Where_is_the_data_stored">Where is the data stored?</h2>

<p>Each storage type represents a separate repository. Here's the actual mapping to directories under a user's Firefox profile (other browsers may differ slightly):</p>

<ul>
 <li><code>&lt;profile&gt;/storage</code> — the main top-level directory for storages maintained by the quota manager (see below)</li>
 <li><code>&lt;profile&gt;/storage/permanent</code> — persistent data storage repository</li>
 <li><code>&lt;profile&gt;/storage/temporary</code> — temporary data storage repository</li>
 <li><code>&lt;profile&gt;/storage/default</code> — default data storage repository</li>
</ul>

<div>
<div class="note">
<p><strong>Note</strong>: After introducing <a href="/en-US/docs/Web/API/Storage_API">Storage API</a>, the "permanent" folder can be considered obsolete; the "permanent" folder only stores IndexedDB persistent-type databases. It doesn't matter if box mode is "best-effort" or "persistent" — data is stored under &lt;profile&gt;/storage/default.</p>
</div>
</div>

<div class="note">
<p><strong>Note</strong>: In Firefox, you can find your profile folder by entering <code>about:support</code> in the URL bar, and pressing the <em>Show in...</em> button (e.g., <em>Show in Finder</em> on Mac OS X) next to the <em>Profile Folder</em> title.</p>
</div>

<div class="note">
<p><strong>Note</strong>: If you are looking around in your Profile at the data stored, you might see a fourth folder: <code>persistent</code>. Basically, the <code>persistent</code> folder was renamed to <code>permanent</code> a while ago to keep upgrades/migration simpler.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Users shouldn’t add their own directories or files under <code>&lt;profile&gt;/storage</code>. This will cause storage initialization to fail; for example, {{domxref("IDBFactory.open()", "open()")}} will fire an error event.</p>
</div>

<h2 id="Storage_limits">Storage limits</h2>

<p>The maximum browser storage space is dynamic — it is based on your hard drive size. The <strong>global limit</strong> is calculated as 50% of free disk space. In Firefox, an internal browser tool called the Quota Manager keeps track of how much disk space each origin is using up, and deletes data if necessary.</p>

<p>So if your hard drive is 500 GB, then the total storage for a browser is 250 GB. If this is exceeded, a process called <strong>origin eviction</strong> comes into play, deleting an entire origin's worth of data until the storage amount goes under the limit again. There is no trimming effect put in place to delete parts of origins — deleting one database of an origin could cause problems with inconsistency.</p>

<p>There's also another limit called <strong>group limit</strong> — this is defined as 20% of the global limit, but it has a minimum of 10 MB and a maximum of 2 GB. Each origin is part of a group (group of origins). There's one group for each eTLD+1 domain. For example:</p>

<ul>
 <li><code>mozilla.org</code> — group1, origin1</li>
 <li><code>www.mozilla.org</code> — group1, origin2</li>
 <li><code>joe.blogs.mozilla.org</code> — group1, origin3</li>
 <li><code>firefox.com</code> — group2, origin4</li>
</ul>

<p>In this group, <code>mozilla.org</code>, <code>www.mozilla.org</code>, and <code>joe.blogs.mozilla.org</code> can aggregately use a maximum of 20% of the global limit. <code>firefox.com</code> has a separate maximum of 20%.</p>

<p>The two limits react differently to limits being reached:</p>

<ul>
 <li>The group limit is also called the "hard limit": it doesn't trigger origin eviction.</li>
 <li>The global limit is a "soft limit" since there's a chance that some space will be freed and the operation can continue.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: The group limit can't be more than the global limit, despite the minimum group limit mentioned above. If you had a really low memory situation where the global limit was, say, 8 MB, then the group limit would also be 8 MB.</p>
</div>

<div class="note">
<p><strong>Note</strong>: If the group limit is exceeded, or if origin eviction couldn't free enough space, the browser will throw a <code>QuotaExceededError</code>.</p>
</div>

<div class="note">
<p><strong>Note</strong>: In Chrome the soft and hard storage quota limits has changed since <strong>M66</strong>. More information can be found <a href="https://chromium.googlesource.com/chromium/src/+/refs/heads/master/storage/browser/quota/quota_settings.cc#68">here.</a></p>
</div>

<h2 id="LRU_policy">LRU policy</h2>

<p>When the available disk space is filled up, the quota manager will start clearing out data based on an LRU policy — the least recently used origin will be deleted first, then the next one, until the browser is no longer over the limit.</p>

<p>We track the "last access time" for each origin using temporary storage. Once the global limit for temporary storage is reached (more on the limit later), we try to find all currently unused origins (i.e., ones with no tabs/apps open that are keeping open datastores). These are then sorted according to "last access time." The least recently used origins are then deleted until there's enough space to fulfill the request that triggered this origin eviction.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.html5rocks.com/en/tutorials/offline/quota-research/">Working with quota on mobile browsers</a>, by<a href="http://blog.agektmr.com" title="Eiji Kitamura"> Eiji Kitamura.</a> A detailed analysis of client-side storage on mobile browsers.</li>
 <li><a href="https://developers.google.com/web/updates/2011/11/Quota-Management-API-Fast-Facts">Quota Management API: Fast Facts</a>, by<a href="http://blog.agektmr.com" title="Eiji Kitamura"> Eiji Kitamura.</a> A look at the Quota Management API in Chrome/Blink (which should include Opera, too).</li>
</ul>
